{-# LANGUAGE DeriveAnyClass #-}
module Horizon.Spec.Types.HorizonExport (HorizonExport(MakePackageSet, MakeOverlay)) where

import           Data.Kind                                   (Type)
import           Dhall                                       (FromDhall,
                                                              Generic, ToDhall)
import           Horizon.Spec.Types.OverlayExportSettings    (OverlayExportSettings)
import           Horizon.Spec.Types.PackageSetExportSettings (PackageSetExportSettings)

type HorizonExport :: Type
data HorizonExport where
  MakePackageSet :: PackageSetExportSettings -> HorizonExport
  MakeOverlay :: OverlayExportSettings -> HorizonExport
  deriving stock (Show, Eq, Generic)
  deriving anyclass (FromDhall, ToDhall)
