{-# LANGUAGE DeriveAnyClass #-}
module Horizon.Spec.Types.PackageSetExportSettings (PackageSetExportSettings(MkPackageSetExportSettings), packagesDir, packageSetFile, packageSet) where

import           Data.Kind                         (Type)
import           Dhall                             (FromDhall, Generic, ToDhall)
import           Horizon.Spec.Types.PackagesDir    (PackagesDir)
import           Horizon.Spec.Types.PackageSet     (PackageSet)
import           Horizon.Spec.Types.PackageSetFile (PackageSetFile)

type PackageSetExportSettings :: Type
data PackageSetExportSettings where
  MkPackageSetExportSettings :: { packagesDir :: PackagesDir
                                , packageSetFile :: PackageSetFile
                                , packageSet :: PackageSet } -> PackageSetExportSettings
  deriving stock (Show, Eq, Generic)
  deriving anyclass (FromDhall, ToDhall)
